// -*- c++ -*-
//------------------------------------------------------------------------------
// $Id: AppearancePrefs.h,v 1.7 2009/07/17 02:12:38 vlg Exp $
//------------------------------------------------------------------------------
//                            AppearancePrefs.h
//------------------------------------------------------------------------------
//  Copyright (c) 2006 by Vladislav Grinchenko
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Sun Sep 3 2006
//
//------------------------------------------------------------------------------

#ifndef APPEAR_PREFS_H
#define APPEAR_PREFS_H

#include <gtkmm/entry.h>
#include <gtkmm/button.h>
#include <gtkmm/box.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/label.h>
#include <gtkmm/table.h>

class PrefWindow;
class TextAlignment;
class FontsSelectorUI;
class ColorsSelectorUI;

/**-----------------------------------------------------------------------------
 *	General Preferences tab
 **-----------------------------------------------------------------------------
 */
class AppearancePrefs : public Gtk::VBox
{  
public:
    AppearancePrefs (PrefWindow& parent_);

    void changed_cb        ();
    void load_from_config  ();
    void save_to_config    ();

protected:
    PrefWindow&        m_pref_window;

	FontsSelectorUI*   m_fonts_selector;
	ColorsSelectorUI*  m_colors_selector;
	TextAlignment*     m_text_alignment;
};

#endif /* APPEAR_PREFS */
