// -*- c++ -*-
//------------------------------------------------------------------------------
// $Id: GeneralPref.h,v 1.14 2009/07/17 02:12:38 vlg Exp $
//------------------------------------------------------------------------------
//                            GeneralPref.h
//------------------------------------------------------------------------------
//  Copyright (c) Vladislav Grinchenko
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Creation Date : Sun May 30 21:09:23 EDT 2004
//
//------------------------------------------------------------------------------

#ifndef GENERAL_PREF_H
#define GENERAL_PREF_H

#include <gtkmm/entry.h>
#include <gtkmm/button.h>
#include <gtkmm/box.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/label.h>
#include <gtkmm/table.h>
#include <gtkmm/fontselection.h>

class PrefWindow;

/**-----------------------------------------------------------------------------
 **	Compound history size option
 **-----------------------------------------------------------------------------
 */
class HistSizeBox : public Gtk::HBox
{
public:
	HistSizeBox ();

	Gtk::Entry* get_entry () { return m_entry; }
	void set_value (int v_);
	int  get_value ();

private:
	Gtk::Label*  m_label;
	Gtk::Entry*  m_entry;
};

/**-----------------------------------------------------------------------------
 *	General Preferences tab
 **-----------------------------------------------------------------------------
 */
class GeneralPref : public Gtk::VBox
{  
public:
    GeneralPref (PrefWindow& parent_);

    void changed_cb        ();
    void load_from_config  ();
    void save_to_config    ();

protected:
    PrefWindow&       m_pref_window;

    Gtk::CheckButton* m_dup_checkbutton;
	Gtk::CheckButton* m_relpath_checkbutton;
	Gtk::CheckButton* m_keys_shortcuts_checkbutton;
	Gtk::CheckButton* m_auto_pronounce_checkbutton;
	Gtk::CheckButton* m_va_control_checkbutton;
	Gtk::CheckButton* m_si_control_checkbutton;

	HistSizeBox*      m_hist_size;
};

#endif /* GENERAL_PREF_H */
